<?php
/*---------------------------------------------------------------*/
/*
    Titre : Jours fériés en France                                                                                      
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=641
    Auteur           : developpeurweb                                                                                     
    Website auteur   : http://rodic.fr                                                                                    
    Date dition     : 02 Mai 2011                                                                                        
    Date mise  jour : 13 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
    - amélioration du code                                                                                               
*/
/*---------------------------------------------------------------*/

      function dimanche_paques($annee)
    {
        return date("Y-m-d", easter_date($annee));
    }
    function vendredi_saint($annee)
    {
        $dimanche_paques = dimanche_paques($annee);
        return date("Y-m-d", strtotime("$dimanche_paques -2 day"));
    }
    function lundi_paques($annee)
    {
        $dimanche_paques = dimanche_paques($annee);
        return date("Y-m-d", strtotime("$dimanche_paques +1 day"));
    }
    function jeudi_ascension($annee)
    {
        $dimanche_paques = dimanche_paques($annee);
        return date("Y-m-d", strtotime("$dimanche_paques +39 day"));
    }
    function lundi_pentecote($annee)
    {
        $dimanche_paques = dimanche_paques($annee);
        return date("Y-m-d", strtotime("$dimanche_paques +50 day"));
    }
    
    
    function jours_feries($annee, $alsacemoselle=false)
    {
        $jours_feries = array
        (    dimanche_paques($annee)
        ,    lundi_paques($annee)
        ,    jeudi_ascension($annee)
        ,    lundi_pentecote($annee)
        
        ,    "$annee-01-01"        //    Nouvel an
        ,    "$annee-05-01"        //    Fête du travail
        ,    "$annee-05-08"        //    Armistice 1945
        ,    "$annee-05-15"        //    Assomption
        ,    "$annee-07-14"        //    Fête nationale
        ,    "$annee-11-11"        //    Armistice 1918
        ,    "$annee-11-01"        //    Toussaint
        ,    "$annee-12-25"        //    Noël
        );
        if($alsacemoselle)
        {
            $jours_feries[] = "$annee-12-26";
            $jours_feries[] = vendredi_saint($annee);
        }
        sort($jours_feries);
        return $jours_feries;
    }
    function est_ferie($jour, $alsacemoselle=false)
    {
        $jour = date("Y-m-d", strtotime($jour));
        $annee = substr($jour, 0, 4);
        return in_array($jour, jours_feries($annee, $alsacemoselle));
    }
?>